var bricks = window.bricks || {};
/*
we use videojs for video play
https://videojs.com
*/
bricks.Video = class extends bricks.Layout {
	/*
	{
		vtype:
		url:
		autoplay:
	}
	*/
	constructor(options){
		super(options);
		this.dom_element.type="application/vnd.apple.mpegurl";
		this.set_css('video-js');
		this.set_css('vjs-big-play-centered');
		this.set_css('vjs-fluid');
		this.cur_url = options.url;
		this.cur_vtype = options.type;
		schedule_once(this.create_player.bind(this), 0.1);
		this.hidedbtn = new bricks.Button({text:'click me'});
		this.hidedbtn.hide();
		this.add_widget(this.hidedbtn);
		this.hidedbtn.bind('click', this.play.bind(this));
	}
	create(){
		var e;
		e = document.createElement('video');
		e.controls = true;
		this.dom_element = e;
	}
	disable_captions(){
		this.player.nativeTextTracks = false;
		var tt =  this.player.textTracks()
		console.log('textTracks=', tt);
		if (tt){
			for(var i=0;i<tt.length;i++){
				tt[i].mode = 'disabled';
			}
		}
	}
	auto_play(){
		this.hidedbtn.dispatch('click');
		schedule_once(this.disable_captions.bind(this), 2);
	}
	play(){
		this.player.play();
	}
	create_player(){
		console.log('here2');
		this.player = videojs(this.dom_element, {
			textTrackSettings: false
		});
		
		this.player.ready(this.auto_play.bind(this));
		this._set_source();
		if (this.opts.autoplay){
			// schedule_once(this.auto_play.bind(this), 0.1);
			;
		}
		console.log('here3', this.player);
	}
	_set_source(){
		this.player.src({
			src:this.cur_url,
			type:this.cur_vtype
		});
    }
	set_source(url, vtype){
		this.cur_url = url;
		this.cur_vtype = vtype;
		this._set_source();
	}
}

bricks.VideoPlayer = class extends bricks.VBox {
	/* 
	we use [indigo-player](https://github.com/matvp91/indigo-player) as a base.
	inside body, need to add following line before bricks.js
	<script src="https://cdn.jsdelivr.net/npm/indigo-player@1/lib/indigo-pla    yer.js"></script>
	options 
	{
		url:
	}
	*/
	constructor(options){
		super(options);
		var autoplay = '';
		if (this.opts.autoplay){
			autoplay = 'autoplay';
		}
		var url = this.opts.url;
		this.dom_element.innerHTML = `<video width="90%" controls ${autoplay} src="${url}" type="application/vnd.apple.mpegurl" class="media-document mac video" ></video>`;
		this.video = this.dom_element.querySelector('video');
	}
	toggle_play(){
		if (this.video.paused){
			this.video.play();
		} else {
			this.video.pause();
		}
	}
		
}
bricks.Factory.register('VideoPlayer', bricks.VideoPlayer);
bricks.Factory.register('Video', bricks.Video);
